#include "WidgetFactory.h"
#include "MotifWidgets.h"
#include "WindowsWidgets.h"

//uncomment the following to generate Motif widgets 
//#define MOTIF
//uncomment the following to generate Windows widgets 
#define WINDOWS

int main(int argc, char *argv[])
{
   WidgetFactory *widget_factory; 
#ifdef MOTIF
   widget_factory = new MotifWidgetFactory;
#else // WINDOWS
   widget_factory = new WindowsWidgetFactory;
#endif

   Widget* w[2] = {widget_factory->create_button(), 
                   widget_factory->create_menu()};
   w[0]->draw();
   w[1]->draw();
   
   system("PAUSE");
   return EXIT_SUCCESS;
}
