#include <list>
#include <iterator>
using namespace std;
#include "Observer.h"
#include "Observable.h"

void Observable::attach(Observer* o){
	//Attach an observer to the Subject
	_observers.push_back(o);
}

void Observable::detach(Observer* o){
	//Detach an observer from the Subject
	_observers.remove(o);
} 

void Observable::notify(){
	//Iterate through all observers and notify them of an update 
	std::list<Observer*>::iterator iter; 
	for (iter = _observers.begin(); iter != _observers.end(); ++iter) 
		{(*iter)->Update();}
}
