#include <cstdlib>
#include <iostream>
using namespace std;

class SingletonClass
{
  private:
          
    int m_value;
    static SingletonClass *s_instance;

    SingletonClass()
    {
        m_value = 0;
    }

  public:

    int get_value()
    {
        return m_value;
    }

    void increment_value()
    {
        m_value++;
    }

    static SingletonClass *instance()
    {
        if (!s_instance)
          s_instance = new SingletonClass();
        return s_instance;
    }
};

// Allocating and initializing GlobalClass's
// static data member.  The pointer is being
// allocated - not the object itself.
SingletonClass *SingletonClass::s_instance = 0;

void foo(void)
{
  SingletonClass::instance()->increment_value();
  cout << "foo:  global_ptr is " << SingletonClass::instance()->get_value() << '\n';
}

void bar(void)
{
  SingletonClass::instance()->increment_value();
  cout << "bar:  global_ptr is " << SingletonClass::instance()->get_value() << '\n';
}

int main(int argc, char *argv[])
{
  cout << "main: global_ptr is " << SingletonClass::instance()->get_value() << '\n';
  foo();
  bar();
  //SingletonClass s = new SingletonClass(); 
  system("PAUSE");
  return EXIT_SUCCESS;
}


