#include <string>
#include <iostream>
using namespace std;

class SquarePeg {
  public:
     virtual void insertSquarePeg(string str) {
        cout << "SquarePeg insertSquarePeg(): " <<  str;}
};

class RoundPeg {
  public:
    virtual void insertRoundPeg(string str) {
        cout << "RoundPeg insertRoundPeg(): " << str;}
};

class TwoWayPegAdapter: public SquarePeg, public RoundPeg { 
  private: 
    RoundPeg *roundPeg; 
    SquarePeg *squarePeg;
  public: 
    TwoWayPegAdapter(RoundPeg *peg) {
       //a roundPeg is plugged into the adapter
       roundPeg = peg;
       squarePeg = NULL;}
    TwoWayPegAdapter(SquarePeg *peg) {
       //a squarePeg is plugged into the adapter
       squarePeg = peg;
       roundPeg = NULL;}
    void insertRoundPeg(string str) { 
       squarePeg->insertSquarePeg(str); } 
    void insertSquarePeg(string str) { 
       roundPeg->insertRoundPeg(str); }
}; 

int main(int argc, char *argv[])
{
    RoundPeg *roundPeg = new RoundPeg();
    SquarePeg *squarePeg = new SquarePeg();

    SquarePeg *squarePegArray[2] = {squarePeg, 
                                    new TwoWayPegAdapter(roundPeg)};
    squarePegArray[0]->insertSquarePeg("Inserting Square Peg in squarePegArray[0]...\n");
    squarePegArray[1]->insertSquarePeg("Inserting Square Peg in squarePegArray[1]...\n");
        
    RoundPeg *roundPegArray[2]   = {roundPeg,
                                    new TwoWayPegAdapter(squarePeg)};
    roundPegArray[0]->insertRoundPeg("Inserting Round Peg in roundPegArray[0]...\n");
    roundPegArray[1]->insertRoundPeg("Inserting Round Peg in roundPegArray[1]...\n");
    
    
        
    system("PAUSE");
    return EXIT_SUCCESS;
};
